
package kr.co.mkblog.mkblogopenglesexample;

import android.content.Context;
import android.opengl.GLES30;
import android.opengl.Matrix;
import android.util.Log;

import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;

/**
 * Created by mkblog on 2018-11-07
 */
public class mkGLExample {
    //MK: Triangle Vertex
    float mkCubeVertices[] = {
            -0.5f, -0.5f, -0.5f,  0.0f, 0.0f,
            0.5f, -0.5f, -0.5f,  1.0f, 0.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            -0.5f,  0.5f, -0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 0.0f,

            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            0.5f, -0.5f,  0.5f,  1.0f, 0.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 1.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 1.0f,
            -0.5f,  0.5f,  0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,

            -0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            -0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            -0.5f,  0.5f,  0.5f,  1.0f, 0.0f,

            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,

            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,
            0.5f, -0.5f, -0.5f,  1.0f, 1.0f,
            0.5f, -0.5f,  0.5f,  1.0f, 0.0f,
            0.5f, -0.5f,  0.5f,  1.0f, 0.0f,
            -0.5f, -0.5f,  0.5f,  0.0f, 0.0f,
            -0.5f, -0.5f, -0.5f,  0.0f, 1.0f,

            -0.5f,  0.5f, -0.5f,  0.0f, 1.0f,
            0.5f,  0.5f, -0.5f,  1.0f, 1.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            0.5f,  0.5f,  0.5f,  1.0f, 0.0f,
            -0.5f,  0.5f,  0.5f,  0.0f, 0.0f,
            -0.5f,  0.5f, -0.5f,  0.0f, 1.0f
    };

    private float mkPosition[][] = {
            { 0.0f,  0.0f,  0.0f},
            { 2.0f,  5.0f, -15.0f},
            {-1.5f, -2.2f, -2.5f},
            {-3.8f, -2.0f, -12.3f},
            { 2.4f, -0.4f, -3.5f},
            {-1.7f,  3.0f, -7.5f},
            { 1.3f, -2.0f, -2.5f},
            { 1.5f,  2.0f, -2.5f},
            { 1.5f,  0.2f, -1.5f},
            {-1.3f,  1.0f, -1.5f}
    };

    private int[] mkVAO;
    private int[] mkVBO;

    private mkShader mkTriShader;

    private int[] mkLightVAO;
    private int[] mkLightVBO;
    private int[] mkLightEBO;

    private mkShader mkLightShader;

    private int mkNumSphereIndex;

    private float[] cameraLocation;

    private float[] mkLightLocation;

    long lastFrameTime;

    private float mkYaw, mkPitch;

    private float mkZoom;

    private float mkLightColor[] = {1.0f, 1.0f, 1.0f};

    public mkGLExample(Context inputContext){
        mkYaw = 270.0f;
        mkPitch = 0.0f;
        mkZoom = 45.0f;

        mkTriShader = new mkShader(inputContext, "mkVertexCode", "mkFragmentCode");

        //MK: Make VAO, VBO
        mkVAO = new int[1];
        GLES30.glGenVertexArrays(1, mkVAO, 0);

        mkVBO = new int[1];
        GLES30.glGenBuffers(1, mkVBO, 0);

        //MK: VAO Bind 이후에 Bind되는 VBO, EBO는 VAO에 저장되는 것으로 판단됨
        GLES30.glBindVertexArray(mkVAO[0]);

        //MK: VBO Bind
        GLES30.glBindBuffer(GLES30.GL_ARRAY_BUFFER, mkVBO[0]);

        //MK: Vertex 좌표를 mkVBO로 복사하는 과정
        ByteBuffer mkByteBuffer = ByteBuffer.allocateDirect(mkCubeVertices.length * 4);
        mkByteBuffer.order(ByteOrder.nativeOrder());
        FloatBuffer mkVertexBuffer = mkByteBuffer.asFloatBuffer();
        mkVertexBuffer.put(mkCubeVertices);
        mkVertexBuffer.position(0);

        GLES30.glBufferData(GLES30.GL_ARRAY_BUFFER, mkCubeVertices.length*4, mkVertexBuffer, GLES30.GL_STATIC_DRAW );

        //MK: mkVBO의 Offset, Vec사이즈 등을 설정하는 부분
        GLES30.glVertexAttribPointer(0, 3, GLES30.GL_FLOAT, false, 5 * 4, 0);
        //MK: mkVBO가 한개 Bind되어서 0으로 설정한듯 함 (계속 공부를 하면서 알아볼 필요가 있음)
        GLES30.glEnableVertexAttribArray(0);


        mkGenSphereVertex tmp = new mkGenSphereVertex(18, 38, 2);
        tmp.generateVertex();
        tmp.generateIndex();
        Log.d("MK", "# of Vertex: " + tmp.mkSphereVertexList.length + "# of Index: " + tmp.mkSphereIndexList.length);

        mkLightShader = new mkShader(inputContext, "mkVertexCode", "mkLightFragmentCode");

        mkLightVAO = new int[1];
        GLES30.glGenVertexArrays(1, mkLightVAO, 0);

        mkLightVBO = new int[1];
        GLES30.glGenBuffers(1, mkLightVBO, 0);

        mkLightEBO = new int[1];
        GLES30.glGenBuffers(1, mkLightEBO, 0);

        GLES30.glBindVertexArray(mkLightVAO[0]);

        GLES30.glBindBuffer(GLES30.GL_ARRAY_BUFFER, mkLightVBO[0]);

        mkByteBuffer = ByteBuffer.allocateDirect(tmp.mkSphereVertexList.length * 4);
        mkByteBuffer.order(ByteOrder.nativeOrder());
        mkVertexBuffer = mkByteBuffer.asFloatBuffer();
        mkVertexBuffer.put(tmp.mkSphereVertexList);
        mkVertexBuffer.position(0);

        GLES30.glBufferData(GLES30.GL_ARRAY_BUFFER, tmp.mkSphereVertexList.length * 4, mkVertexBuffer, GLES30.GL_STATIC_DRAW);

        GLES30.glVertexAttribPointer(0, 3, GLES30.GL_FLOAT, false, 3 * 4, 0);

        GLES30.glEnableVertexAttribArray(0);

        GLES30.glBindBuffer(GLES30.GL_ELEMENT_ARRAY_BUFFER, mkLightEBO[0]);

        mkByteBuffer = ByteBuffer.allocateDirect(tmp.mkSphereIndexList.length * 4);
        mkByteBuffer.order(ByteOrder.nativeOrder());
        IntBuffer mkIndexBuffer = mkByteBuffer.asIntBuffer();
        mkIndexBuffer.put(tmp.mkSphereIndexList);
        mkIndexBuffer.position(0);

        GLES30.glBufferData(GLES30.GL_ELEMENT_ARRAY_BUFFER, tmp.mkSphereIndexList.length * 4, mkIndexBuffer, GLES30.GL_STATIC_DRAW);

        mkNumSphereIndex = tmp.mkSphereIndexList.length;

        //MK: Camera Location
        cameraLocation = new float[3];
        cameraLocation[0] = 0.0f;
        cameraLocation[1] = 0.0f;
        cameraLocation[2] = 3.0f;

        mkLightLocation = new float[3];
        mkLightLocation[0] = 1.2f;
        mkLightLocation[1] = 1.0f;
        mkLightLocation[2] = 2.0f;

        lastFrameTime = System.currentTimeMillis();
    }

    private float[] mkViewMatrix;
    private float[] mkProjectionMatrix;
    private float[] mkModelMatrix;

    public float[] crossProduct(float[] lhs, float[] rhs){
        float output[] = {0.0f, 0.0f, 0.0f};
        output[0] = lhs[1] * rhs[2] - lhs[2] * rhs[1];
        output[1] = lhs[2] * rhs[0] - lhs[0] * rhs[2];
        output[2] = lhs[0] * rhs[1] - lhs[1] * rhs[0];
        return output;
    }

    public float[] normalized(float[] input){
        float output[] = {0.0f, 0.0f, 0.0f};
        float magnitude = (float) Math.sqrt(input[0] * input[0] + input[1] * input[1] + input[2] * input[2]);
        output[0] = input[0] / magnitude;
        output[1] = input[1] / magnitude;
        output[2] = input[2] / magnitude;
        return output;
    }

    public float[] vectorMul( float lhs, float[] rhs){
        float output[] = {rhs[0] * lhs, rhs[1] * lhs, rhs[2] * lhs};
        return output;
    }

    public void calculateViewAndProjectionMatrix(float width, float height, float directionX, float directionY, float angleX, float angleY, float zoomValue){

        //MK: Object가 보이는 방향을 결정하는 부분?
        mkViewMatrix = new float[16];
        //Matrix.setIdentityM(mkViewMatrix, 0);
        //Matrix.translateM(mkViewMatrix, 0, 0.0f, 0.0f, -3.0f);
        //MK: 간단히 함수 하나를 쓰면 Camera의 위치에 따라 ViewMatrix 설정이 가능함.
        //MK: 하지만, 정확하게 이해하기에는 다소 어려움이 있는 것 같음. Coordinate 관련해서는 계속 공부를 할 필요가 있음
        //long milliSecond = System.currentTimeMillis()/10;
        //float rotateAngle = milliSecond % 360;
        //MK: sin/cos을 사용하기 위해서 toRadians를 사용해서 PI값으로 변경해야 함.
        //rotateAngle = (float) Math.toRadians(rotateAngle);
        //float radius = 10.0f;
        //double camX = Math.sin(rotateAngle) * radius;
        //double camZ = Math.cos(rotateAngle) * radius;
        //MK: Delta 값을 사용하여 Camera 속도 변경
        long currentTime = System.currentTimeMillis();
        long delta = currentTime - lastFrameTime;
        lastFrameTime = currentTime;

        float cameraSpeed = 0.005f * (float)delta;

        //MK: 오른쪽/왼쪽/앞/뒤로 이동하기 위한 camara 위치 변경하는 코드 수정
        cameraLocation[2] += directionY/10 * cameraSpeed;


        mkYaw += angleX * cameraSpeed * 0.5f;
        mkPitch += angleY * cameraSpeed * 0.5f;

        //MK: Pitch 값이 90을 넘어가면 camaraUp vector가 변경되야 화면이 정상적으로 출력될 것 같음
        //MK: 이부분은 아직 추측이긴 한데 아마도 맞을 것 같음
        if(mkPitch >= 89.0f){
            mkPitch = 89.0f;
        }
        else if(mkPitch <= -89.0f){
            mkPitch = -89.0f;
        }

        float[] cameraFront = {0.0f, 0.0f, 0.0f};
        //MK: mkPitch와 mkYaw를 사용하여 CameraFront 값을 계산하는 부분
        //MK: Camera Front의 경우 Camera가 보는 위치를
        cameraFront[0] = (float) Math.cos(Math.toRadians(mkPitch)) * (float)Math.cos(Math.toRadians(mkYaw));
        cameraFront[1] = (float) Math.sin(Math.toRadians(mkPitch));
        cameraFront[2] = (float) Math.cos(Math.toRadians(mkPitch)) * (float)Math.sin(Math.toRadians(mkYaw));
        cameraFront = normalized(cameraFront);

        float[] cameraUp = {0.0f, 1.0f, 0.0f};
        float[] tmp = crossProduct(cameraFront, cameraUp);
        tmp = vectorMul(cameraSpeed, normalized(tmp));
        if(directionX > 0) {
            cameraLocation[0] += tmp[0];
            cameraLocation[1] += tmp[1];
            cameraLocation[2] += tmp[2];
        }
        else if(directionX < 0) {
            cameraLocation[0] -= tmp[0];
            cameraLocation[1] -= tmp[1];
            cameraLocation[2] -= tmp[2];
        }

        Matrix.setLookAtM(mkViewMatrix, 0 , cameraLocation[0], cameraLocation[1], cameraLocation[2], cameraLocation[0] + cameraFront[0], cameraLocation[1] + cameraFront[1], cameraLocation[2] + cameraFront[2], 0.0f, 1.0f, 0.0f);

        //MK: ProjectionMatrix로 Depth에 따른 물체가 보이는 형태를 결정하는 부분
        mkProjectionMatrix = new float[16];
        mkZoom += zoomValue * cameraSpeed;
        if(mkZoom >= 45.0f){
            mkZoom = 45.0f;
        }
        else if(mkZoom <= 1.0f){
            mkZoom = 1.0f;
        }
        Matrix.perspectiveM(mkProjectionMatrix, 0, mkZoom, width/height, 0.1f, 100.0f);

        //MK: 보통 Matrix는 반대로 읽어야 한다고 함.
        //MK: modelMatrix * vertex Vector ==> World Space 로 변경
        //MK: viewMatrix * modelMatrix * vertex Vector ==> View Space로 변경 //정확하진 않는데 아마도 1.0, -1.0등의 좌표가 아니라 사용자가 정의한 값에서 보이는 방향등을 결정하는 단계
        //MK: projectionMatrix * viewMatrix * modelMatrix * vertex Vector ==> clip Space로 변경 //W 값을 나누는 작업과, 1.0 ~ -1.0 사이 값으로 변경하는 Normalizing 작업을 수행
        //MK: Clip Space에서 Screen Space로 변경하는 과정은 ViewPort라는 Hardware Logic이 자동적으로 수행하는 것으로 판단됨.
    }

    public void calculateModelMatrix(float[] translateM, float rotateAngle, float scaleFactor){
        //MK: Model의 위치나, Rotate 방향등을 결정하는 부분
        mkModelMatrix = new float[16];
        //long milliSecond = System.currentTimeMillis()/50;
        //float rotateAngle = milliSecond % 720;
        //rotateAngle -= 360;
        //rotateAngle %= 360;
        float[] mkTmp = new float[16];
        Matrix.setIdentityM(mkTmp, 0);
        Matrix.translateM(mkTmp, 0, translateM[0], translateM[1], translateM[2]);
        Matrix.setRotateM(mkModelMatrix, 0, rotateAngle, 1.0f, 0.3f, 0.5f);
        Matrix.multiplyMM(mkModelMatrix, 0, mkTmp, 0, mkModelMatrix, 0);
        Matrix.scaleM(mkModelMatrix, 0, scaleFactor, scaleFactor, scaleFactor);
    }

    public void draw(float width, float height, float locationX, float locationY, float angleX, float angleY, float zoomValue){

        //MK: Draw Triangles
        mkTriShader.use();
        GLES30.glBindVertexArray(mkVAO[0]);

        calculateViewAndProjectionMatrix(width, height, locationX, locationY, angleX, angleY, zoomValue);

        mkTriShader.setUniformMatrix4("mkView", mkViewMatrix);
        mkTriShader.setUniformMatrix4("mkProjection", mkProjectionMatrix);

        mkTriShader.setUniformVec3("lightColor", mkLightColor);

        float objectColor[] = {1.0f, 0.5f, 0.31f};

        mkTriShader.setUniformVec3("objectColor", objectColor);

        for(int i = 0; i < 1; i ++) {
            calculateModelMatrix(mkPosition[i], 0, 1.0f);
            mkTriShader.setUniformMatrix4("mkModel", mkModelMatrix);
            GLES30.glDrawArrays(GLES30.GL_TRIANGLES, 0, 36);
        }

        mkLightShader.use();
        GLES30.glBindVertexArray(mkLightVAO[0]);
        calculateModelMatrix(mkLightLocation, 0, 0.05f);
        //MK: 새로운 Shader Program을 사용하면 Uniform 데이터를 모두 업데이트 해야함
        mkTriShader.setUniformMatrix4("mkView", mkViewMatrix);
        mkTriShader.setUniformMatrix4("mkProjection", mkProjectionMatrix);
        mkTriShader.setUniformMatrix4("mkModel", mkModelMatrix);
        //GLES30.glDrawArrays(GLES30.GL_TRIANGLES, 0, 36);
        GLES30.glDrawElements(GLES30.GL_TRIANGLES, mkNumSphereIndex, GLES30.GL_UNSIGNED_INT, 0);
    }
}

