package kr.co.mkblog.mkblogopenglesexample;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.view.MotionEvent;

public class mkGLSurfaceView extends GLSurfaceView{

    private final Context mkContext;
    private mkGLRenderer mkRender;

    //MK: Touch 관련해서 위치 계산을 위한 코드
    private int mkThreeFinPreviousX;
    private int mkThreeFinPreviousY;
    private float mkTwoFinDistance;
    //private int mkTwoFinPreviousY;
    private int mkOneFinPreviousX;
    private int mkOneFinPreviousY;

    private int previousStage;

    public mkGLSurfaceView(Context tmp) {
        super(tmp);
        mkContext = tmp;
        setEGLContextClientVersion(3);

        mkRender = new mkGLRenderer(tmp);
        setRenderer(mkRender);
        previousStage = 0;
    }

    @Override
    public boolean onTouchEvent(MotionEvent event) {

        if(event.getPointerCount() == 1){
            int firstX = (int) event.getX();
            int firstY = (int) event.getY();
            switch(event.getAction()){
                case MotionEvent.ACTION_MOVE:
                    if(previousStage == 1) {
                        int dx = firstX - mkOneFinPreviousX;
                        int dy = firstY - mkOneFinPreviousY;
                        mkRender.setAngleDiff((float) dx, (float) dy);
                        requestRender();
                    }
                    else{
                        previousStage = 1;
                    }
            }
            mkOneFinPreviousX = firstX;
            mkOneFinPreviousY = firstY;
        }
        else if (event.getPointerCount() == 2){
            int firstX = (int) event.getX(0);
            int firstY = (int) event.getY(0);
            int SecondX = (int) event.getX(1);
            int SecondY = (int) event.getY(1);
            float xDistance = firstX - SecondX;
            float yDistance = firstY - SecondY;

            float diff = (float) Math.sqrt((float) (xDistance * xDistance) + (float) (yDistance * yDistance));

            switch (event.getAction()) {

                case MotionEvent.ACTION_MOVE:
                    if(previousStage == 2) {
                        //int dx = firstX - mkTwoFinPreviousX;
                        //int dy = firstY - mkTwoFinPreviousY;
                        //float diff = (float) Math.sqrt((float) (dx * dx) + (float) (dy * dy));
                        mkRender.setZoomDiff(diff - mkTwoFinDistance);
                        //mkRender.setLocationDiff((float)dx, (float)dy);
                        requestRender();
                    }
                    else{
                        previousStage = 2;
                    }
            }
            //mkTwoFinPreviousX = firstX;
            //mkTwoFinPreviousY = firstY;
            mkTwoFinDistance = diff;
        }
        else if (event.getPointerCount() == 3) {
            int firstX = (int) event.getX();
            int firstY = (int) event.getY();
            switch (event.getAction()) {

                case MotionEvent.ACTION_MOVE:
                    if(previousStage == 3) {
                        int dx = firstX - mkThreeFinPreviousX;
                        int dy = firstY - mkThreeFinPreviousY;
                        mkRender.setLocationDiff((float) dx, (float) dy);
                        requestRender();
                    }
                    else{
                        previousStage = 3;
                    }
            }
            //mkOneFinPreviousX = firstX;
            //mkOneFinPreviousY = firstY;
            mkThreeFinPreviousX = firstX;
            mkThreeFinPreviousY = firstY;
        }
        return true;
    }
}
