package kr.co.mkblog.mkblogopenglesexample;

import java.util.ArrayList;
import java.util.List;

public class mkGenSphereVertex {

    private int mkStackCounter;
    private int mkSectorCounter;
    private float mkRadius;

    public float[] mkSphereVertexList;
    public int[] mkSphereIndexList;

    public mkGenSphereVertex(int stackCounter, int sectorCounter, int radius){
        mkStackCounter = stackCounter;
        mkSectorCounter = sectorCounter;
        mkRadius = radius;
    }

    public void generateVertex(){
        List<Float> mkSphereVertex;
        List<Float> mkNormal;
        List<Float> mkTextureCoord;

        mkSphereVertex = new ArrayList<>();
        mkNormal = new ArrayList<>();
        mkTextureCoord = new ArrayList<>();
        float sectorStep = 2 * (float)Math.PI / mkSectorCounter;
        float stackStep = (float)Math.PI / mkStackCounter;
        float lengthInv = 1.0f/mkRadius;

        for(int i = 0; i < mkStackCounter + 1; i++){
            float stackAngle = (float) Math.PI / 2 - i * stackStep;
            float xy = mkRadius * (float) Math.cos(stackAngle);
            float z = mkRadius * (float) Math.sin(stackAngle);

            for(int j = 0; j < mkSectorCounter + 1; j++){
                float sectorAngle = j * sectorStep;
                float x = xy * (float)Math.cos(sectorAngle);
                float y = xy * (float)Math.sin(sectorAngle);
                mkSphereVertex.add(x);
                mkSphereVertex.add(y);
                mkSphereVertex.add(z);

                float nx = x * lengthInv;
                float ny = y * lengthInv;
                float nz = z * lengthInv;
                mkNormal.add(nx);
                mkNormal.add(ny);
                mkNormal.add(nz);

                float s = (float)j / mkSectorCounter;
                float t = (float)i / mkStackCounter;
                mkTextureCoord.add(s);
                mkTextureCoord.add(t);
            }
        }
        mkSphereVertexList = new float[mkSphereVertex.size()];
        for(int i = 0; i < mkSphereVertex.size(); i++){
            mkSphereVertexList[i] = mkSphereVertex.get(i);
        }
    }

    public void generateIndex(){
        List<Integer> mkIndex;
        mkIndex = new ArrayList<>();
        int k1, k2;
        for(int i = 0; i < mkStackCounter; ++i)
        {
            k1 = i * (mkSectorCounter + 1);
            k2 = k1 + mkSectorCounter + 1;
            for(int j = 0; j < mkSectorCounter; ++j, ++k1, ++k2)
            {
                if(i != 0)
                {
                    mkIndex.add(k1);
                    mkIndex.add(k2);
                    mkIndex.add(k1 + 1);
                }
                if(i != (mkStackCounter-1))
                {
                    mkIndex.add(k1 + 1);
                    mkIndex.add(k2);
                    mkIndex.add(k2 + 1);
                }
            }
        }
        mkSphereIndexList = new int[mkIndex.size()];
        for(int i = 0; i < mkIndex.size(); i++){
            mkSphereIndexList[i] = mkIndex.get(i);
        }

    }
}
